Object.byString = function(o, s) {
    s = s.replace(/\[(\w+)\]/g, '.$1'); // convert indexes to properties
    s = s.replace(/^\./, '');           // strip a leading dot
    var a = s.split('.');
    for (var i = 0, n = a.length; i < n; ++i) {
        var k = a[i];
        if (k in o) {
            o = o[k];
        } else {
            return;
        }
    }
    return o;
}

window.Templator = (function(w, rs) {
	var obj = {},
		root;

	obj.use = function(id, data) {
		if (!root) root = $(rs)
		if (!data) data = {};

		var el = $("xmp#" + id, root),
			result;

		if (!el) {
			return 'Неизвестный шаблон "' + el + '"'; // obj.use("error", { text: "Templator: undefined id" });
		}
		result = el.innerHTML;

		result = result.replace(/\{([a-zA-Z\.\_]+)\}/g, function(m, path) {
			var d = Object.byString(data, path);

			return d ? d : '';
		});

		return result;
	};


	return obj;
})(window, window.TemplatorSelectorRoot);